#ifndef   __ADC_
#define  __ADC_

#define   uint8_t  unsigned char
#define   uint16_t unsigned long int

typedef struct adcvar
{
  uint8_t   u8AdcLast; 
  uint8_t   u8AdcNow;  
  uint8_t   u8AdcFilterValue;          
  uint8_t   max;
  uint8_t   min;
  uint16_t  sum;
  uint8_t   u8Step;
  uint8_t   cnt;    
}ADCVAR;

extern ADCVAR adcBattery;   //صѹ 
extern ADCVAR adcadzz; //ת
extern ADCVAR adcadfz; //ת

void read_adc_chs(void);
void ADC_Filter(ADCVAR *adcvar);
void Get_ADC(ADCVAR *adcvar);
#endif