#line 1 ".\Src\time.c"
#line 1 "D:\SN8STU~1\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\time.c"
#line 1 ".\Include\FC2720.h"


#line 6 ".\Include\FC2720.h"








struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;






sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;

sbit	LVDF =0x86:5;















 sfr    TM1M    =0XA0;
 sfr    TM1C   =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1  =0XA3;
 sfr    TM1D2  =0XA4;
 sfr    TM1D3  =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;

 sfr    TM2M    =0XB0;
 sfr    TM2C   =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1  =0XB3;
 sfr    TM2D2  =0XB4;
 sfr    TM2D3  =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;

 sfr    TKCON=  0X88;
 sfr    TKTMD =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKMIO  =0X8F;

 sfr    ADM =0XB9;
 sfr    ADB =0XBa;
 sfr    ADR =0XBb;
 sfr    ADT =0XBc;
 sfr    VREFH =0XBd;
 sfr    ADPCON =0XBe;
 sfr	PEDGE =0XBF;

 sfr    P1W = 0XC0;
 sfr	P1M = 0xc1;
 sfr	P3M=0XC3;
 sfr    INTRQ1 = 0XC6;
 sfr    INTEN1 = 0XC7;
 sfr    INTRQ = 0XC8;
 sfr    INTEN = 0XC9;
 sfr	OSCM = 0xca;
 sfr	RCADJ =0XCB;
 sfr	WDTR =0XCC;
 sfr    OPTION = 0XCD;
 sfr	PCL =0XCE;
 sfr	PCH =0XCF;

 sfr	P1 = 0XD1;
 sfr	P2 = 0XD2;
 sfr	P3 = 0XD3;
 sfr	T0M = 0XD8;
 sfr	T0C = 0XD9;
 sfr    OPA1CON = 0XDA;
 sfr    OPA2CON = 0XDB;
 sfr    P1OD = 0XDC;
 sfr    P3W = 0XDE;
 sfr    STKP = 0XDF;

 sfr	P1UR=0Xe1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;

 sfr	P1PD=0XEC;
 sfr	P3PD=0XEE;

sbit	FP37UR = 0XE3:7;

sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAA:2;
sbit	E2P_PG		=0xA9:1;
sbit	E2P_RD		=0xA8:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	FCHS0		=0xB9:0;
sbit	FCHS1		=0xB9:1;
sbit	FCHS2		=0xB9:2;
sbit	FCHS3		=0xB9:3;
sbit	FGCHS		=0xB9:4;
sbit	EOC		=0xB9:5;
sbit	ADS		=0xB9:6;
sbit	FADENB		=0xB9:7;



sbit	FADCKS0		=0xBB:4;
sbit	FADCKS1		=0xBB:6;



sbit	FADT_0		=0xBc:0;
sbit	FADT_1		=0xBC:1;
sbit	FADT_2		=0xBC:2;
sbit	FADT_3		=0xBC:3;
sbit	FADT_4		=0xBC:4;

sbit	Fadts_0		=0xBC:6;
sbit	Fadts_1		=0xBC:7;


sbit	FVHS0		=0xBD:0;
sbit	FVHS1		=0xBD:1;

sbit	FEVHENB		=0xBD:7;






sbit	FINT0IE		=0xc9:0;
sbit	FINT1IE		=0xc9:1;
sbit	FTM0IE		=0xc9:2;
sbit	FTM1IE		=0xc9:3;
sbit	FTM2IE		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	FI2CIE		=0xc9:6;
sbit	FADCIE		=0xc9:7;

sbit	FE2PIE		=0xc7:0;
sbit	FTKTMRIE	=0xc7:1;
sbit	FSPIIE		=0xc7:2;
sbit	T0IE	    =0xC7:3;
sbit	FOPAIE    	=0xC7:4;

sbit	FINT0IF		=0xc8:0;
sbit	FINT1IF		=0xc8:1;
sbit	FTM0IF		=0xc8:2;
sbit	FTM1IF		=0xc8:3;
sbit	FTM2IF		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	FI2CIF		=0xc8:6;
sbit	FADCIF		=0xc8:7;

sbit	FE2PIF		=0xc6:0;
sbit	FTKTMRIF	=0xc6:1;
sbit	FSPIIF		=0xc6:2;
sbit	T0IF	    =0xC6:3;
sbit	FOPAIF    	=0xC6:4;


sbit	FGIE = 0xdf:7;


sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;


sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;













#line 2 ".\Src\time.c"
#line 1 ".\Src\time.h"



extern bit bit250us;
extern bit bit1ms;
extern bit bit5ms;
extern bit bit10ms;
extern bit bit100ms;
extern bit bit50ms;

extern unsigned char cont_tim;
extern unsigned char cont_30s;

extern void t0_enable(void);
extern void t0_disable(void);

#line 3 ".\Src\time.c"

bit bit250us=0;
bit bit1ms=0;
bit bit5ms=0;
bit bit10ms=0;
bit bit100ms=0;
bit bit50ms=0;

 unsigned char cont_tim=0;
 unsigned char cont_30s=0;


#line 22 ".\Src\time.c"
void __interrupt[0x8] isr(void)
{
  static unsigned char i=0,j=0,x=0,t=0,k=0,cont_1s=0;
  if(T0IF)
  {
    T0C=68;
	j++;
	bit250us=1;
	if(j>3)
	{
		j=0;
		bit1ms=1;
		i++;
		t++;
		x++;
		k++;
	}

	if(i>4)
	{
		i=0;
		bit5ms=1;
	}

	if(t>9)
	{
		t=0;
		bit10ms=1;
	}

	if(k>49)
	{
		k=0;
		bit50ms=1;
	}

	if(x>99)
	{
		x=0;
		bit100ms=1;
		cont_1s++;
	}

	if(cont_1s>9)
	{
		cont_1s=0;
		cont_tim++;
		cont_30s++;
		if(cont_tim==250)
		{
			cont_tim=250;
		}

		if(cont_30s==250)
		{
			cont_30s=250;
		}
	}
	T0IF=0;
  }
}

#line 93 ".\Src\time.c"
void t0_enable(void)
{
	T0M=0XE0;
	T0C=68;
	T0IE=1;
	FGIE=1;
}

