#include "FC2720.h"
#include "key.h"
#include "global.h"
#include "time.h"
#include "adc.h"
#include "delay.h"

uint8_t ledstatus1=0;   //鿪
uint8_t NF_STA=0;       //ON/OFF    

bit work_sta=0;        //ⷢ˿״̬

#define  ADC_NUM_110    197    //12       //197     //     110
#define  ADC_NUM_108    209    //13       //209     //     108


struct LED_STRUCT LED_MODE={0,0,0,0,0,0,0};

/******************************************************************************************************
*      ƣvoid io_pwm_output(void)
*      ܣģPWM
*  ˵    
*  ڲ 
*  ڲ
*      
*      ڣ
*      ߣ
******************************************************************************************************/
#if 1
#define DUTY_MAX  30         //250hz
void io_pwm_output(void)
{
	LED_MODE.u8count++;
	if(LED_MODE.u8count>(DUTY_MAX-1))
	{
		LED_MODE.u8count=0;
		LED_MODE.u8LED1DutyTmp=LED_MODE.u8LED1Duty;
		if(LED_MODE.u8LED1DutyTmp)
		LED_1_ON;
		else
		LED_1_OFF;
	}
	else
	{
		if(LED_MODE.u8count==LED_MODE.u8LED1DutyTmp)
		LED_1_OFF;
	}
}
#endif
/******************************************************************************************************
*      ƣvoid LED_CTR(void)
*      ܣԴָʾơ˿--
*  ˵    
*  ڲ
*  ڲ
*      
*      ڣ
*      ߣ
******************************************************************************************************/
void LED_CTR(void)
{	
	switch(ledstatus1)
	{
		case 0:
		LED_MODE.u8LED1Duty=0;
		//PTC_OFF;
		cont_tim=0;
		work_sta=0;
		break;
		
		case 1:
		//Get_NTC_VOL();
		work_sta=1;
		
		if((cont_tim<4)&&(NF_STA==1))
		{
			if(strucAIN2.u16AdcFilterValue<ADC_NUM_110)      //¶ȸ110϶
			{
				//PTC_OFF;
				LED_MODE.u8LED1Duty=0;
			}

			if(strucAIN2.u16AdcFilterValue>ADC_NUM_108)      //¶ȵ108϶
			{
				//PTC_ON;
				LED_MODE.u8LED1Duty=13;
			}
		}
		else
		{
			cont_tim=0;
			ledstatus1=0;
		}
		
		if(K2_STA==1)
		{
			K2_STA=0;
			cont_tim=0;
		}
		break;
		
		default:
		ledstatus1=0;
		break;
	}
	
	switch(NF_STA)
	{
		case 0:
		NTC_DISABLE;      //رNTC
		POWER_OFF;
		cont_30s=0;
		break;
		
		case 1:
		NTC_ENABLE;      //NTC
		POWER_ON;
		if(work_sta==0)
		{
			if(cont_30s>30)
			{
				NF_STA=0;
			}
		}
		else
		{
			cont_30s=0;
		}
		break;
		
		default:
		NF_STA=0;
		break;
	}
}

/*
void Get_NTC_VOL(void)
{
	static uint8_t u8cnt=0;
	if(strucAIN2.u16AdcFilterValue<=386)     //¶ȸ108϶
	{
		Temperature_Ctr=1;
		u8cnt=0;
	}
	else
	{
		u8cnt++;
		if(u8cnt>4)
		{
			Temperature_Ctr=0;
		}
	}

}*/
/**********************************************************************
*      ƣvoid key_service(void)
*      ܣ
*  ڲ̰־λ
*  ڲ
*  ˵    
*      
*      ڣ2020614
*      : JC
***********************************************************************/
void key_service(void)
{
	if(bitKey[K1].bitShortClick)
	{
		bitKey[K1].bitShortClick=0;
		NF_STA^=1;
	}
	
	if((bitKey[K2].bitShortClick==1)&&(NF_STA==1))
	{
		bitKey[K2].bitShortClick=0;
		ledstatus1=1;
	}
	else
	{
		bitKey[K2].bitShortClick=0;
	}
}
/******************************************************************************************************
*      ƣvoid sleep_mode(void)
*      ܣ˯ģʽ
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ
*      : 
******************************************************************************************************/
#if 1
void sleep_mode(void)
{
	uint8_t u8flag=0;
	if(NF_STA==0)
	{
		system_init();
		bitKey[K1].bitLock=1;
		for(u8flag=0;u8flag<200;u8flag++)
		{
			WDTR=0X5A;
			delay_1ms(1);
			key_scan();
			if(bitKey[K1].bitLock==0)
			break;
		}

		INTEN=0X20;
		do{
			INTRQ=0;
			__asm{SleepMode};
		}while(S_K1);           
	
		INTEN=0;
		INTRQ=0;
		INTRQ1=0;

		if(S_K1==0)
		{
			bitKey[K1].bitLock=1;
			NF_STA^=1;
		}

		t0_enable();
		adc_init();
	}
}
#endif
/******************************************************************************************************
*      ƣvoid system_init(void)
*      ܣϵͳʼ
*  ڲ
*  ڲ
*      ڣ2018.4.13
*      ߣ
******************************************************************************************************/
void system_init(void)
{
  P1   =0x00;
  P1M  =0xF3;      //0 =  ģʽ   1 =  ģʽ	  1111 0011
  P1W  =0x04;      //P12ʹ      0 =         1 =  ʹ           0000 0100
  P1UR =0x0C;      //P13P12    0000 1100 
  P1OD =0x00;
  
  P3   =0x03;       //         0000 0011
  P3M  =0xFF;       // 
  P3W  =0x00;       // 
  P3UR =0x00;       //0 =     1 =  	    0000 0101
  //P3PD =0x00;       //0 =     1 =  


  ADPCON=0x00;     
  ADR   =0x00;   //
  VREFH =0x00;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  ADM   =0x00;   //


  T0M=0x00;	
  T0IE=0; 
  TM1M =0x00;   
  TM2M =0x00;
  PWM1E=0x00;
  PWM2E=0x00;
  FGIE=0;
}