#include "FC2720.h"

#include"adc.h"
#include"key.h"
#include"tim.h"




struct ADC_STRUCT struc12V={0,0,0,0,0,0,0};//12V

/******************************************************************************************************
*      : adc_filter 
*      ܣADC˲
*  ڲ   
*  ڲ
*      ڣ2019.6.15
*      ߣ
******************************************************************************************************/
#define   N      16
void adc_filter(struct ADC_STRUCT *adcvar)
{     
  if(adcvar->u8cnt==0)
  {
    adcvar->u16sum=adcvar->u16AdcValue;
    adcvar->u16min=adcvar->u16AdcValue;
    adcvar->u16max=adcvar->u16AdcValue;
    adcvar->u8cnt=1;                                //һֵ
  }
  else
  {
    if(adcvar->u16AdcValue>adcvar->u16max)
	{
      adcvar->u16max=adcvar->u16AdcValue;            //ֵ	
    }	
    else if(adcvar->u16AdcValue<adcvar->u16min)
    {
      adcvar->u16min=adcvar->u16AdcValue;            //Сֵ
    }
    adcvar->u16sum+=adcvar->u16AdcValue;             //׷ӵֵ
    adcvar->u8cnt++;
    if(adcvar->u8cnt>(N-1))
    {	
      adcvar->u8cnt=0;	
      adcvar->u16sum=adcvar->u16sum-adcvar->u16max-adcvar->u16min;//ƽֵ=(ֵ-ֵ-Сֵ)/(г-2)
      adcvar->u16AdcFilterValue=adcvar->u16sum/(N-2);  
      adcvar->u8adcFinish=1;
    }
  }			  			 
}
/******************************************************************************************************
*      : get_adc 
*      ܣȡADCת,жģʽ
*  ڲ   
*  ڲ
*      ڣ2019.7.1
*      ߣ
******************************************************************************************************/
void get_adc_convert_value(struct ADC_STRUCT *adcvar)
{
  ADS =1;                 //ʼADCת
  while(EOC==0);          //ȴADCת
  adcvar->u16AdcValue=ADB;         
  adcvar->u16AdcValue<<=4;
  adcvar->u16AdcValue +=(ADR&0x0F);
  EOC=0;                  //ADC״̬־λ׼һADC 
}
/******************************************************************************************************
*      ƣvoid ADC_Init(void)
*      ܣʼADC
*  ڲ
*  ڲ
*  ˵    ADC1ĲͨΪڲοѹתģʽ
*      
******************************************************************************************************/
void adc_init(void)
{   
  ADPCON=0x00;  
  ADR  =0x20;   //12λADC
  VREFH=0x00;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  ADC_SELECT_12V_CH;   
}
/******************************************************************************************************
*      : void read_adc_chs(void) 
*      ܣѯADCͨ
*  ڲ   
*  ڲ
*      ڣ2018.1.4
*      ߣ
******************************************************************************************************/
void read_adc_chs(void)
{
  static uint8_t step=0;	
  switch(step)
  {
	case 0:
	{
      get_adc_convert_value(&struc12V);		
	  adc_filter(&struc12V);
	  ADC_SELECT_12V_CH;	  
	  step=1;		  
	}	
	break;
	  
	case 1:
	{
      get_adc_convert_value(&struc12V);			
	  adc_filter(&struc12V);		  
	  ADC_SELECT_12V_CH;	  
	  step=2;
	}	
	break;
	  
	case 2:
	{
      get_adc_convert_value(&struc12V);			
	  adc_filter(&struc12V);
      ADC_SELECT_12V_CH; 	  
	  step=0;
	}	
	break;
	default:		  
	  step=0;	
	break;  
  }
}	

