#include <FC2722.h>
#define   uint8_t  unsigned char
#define   uint16_t unsigned long int
#include"leddisplay.h"
#include"adc.h"
#include"key.h"

#define ALL_COM_IN   COM4_IN;COM1_IN;COM2_IN;COM3_IN;COM5_IN;COM6_IN;    

struct DIS_STRUCT structDis={0,0,0,0,0,0};


 //ԭͼóĹģ
__ROM uint8_t DigTable[13]=
{
  0X3F,  //0       0
  0X06,  //1       1
  0X5B,  //2       2
  0X4F,  //3       3
  0X66,  //4       4
  0X6D,  //5       5
  0X7D,  //6       6
  0X07,  //7       7
  0X7F,  //8       8
  0X6F,  //9       9
  0X00,  //10      ո
  0X40,  //11      -
  0X73,  //12      ĸP
};

/******************************************************************************************************
*      ƣvoid display_drive(void)
*      ܣ6Ŷʾ
*  ڲstructDis.u8hundred       structDis.u8ten  structDis.u8single    structDis.u8left  structDis.u8right
*  ڲ
*  ˵    
*      
*      ڣ202043
*      ߣм
******************************************************************************************************/
void display_drive(void)
{ 
  uint8_t tmp=0;
  switch(structDis.u8step)
  {
    case 0://COM1ߵƽ
    {
      ALL_COM_IN;
	  switch(structDis.u8left)
	  {
        case 0:
		break;	
        
	    case 4:
		  COM2_L;
		  COM2_OUT;
	    //break;
		case 3:
		  COM3_L;
		  COM3_OUT;
		//break;
		case 2:
		  COM4_L;
		  COM4_OUT;
		//break;	
	    case 1:
		  COM5_L;
		  COM5_OUT;
		
		  COM6_L;	
          COM6_OUT; 		
		break;				
	  }
      COM1_H;
      COM1_OUT; 
    }   
    break;
    
    case 1://COM2ߵƽ
    {
      ALL_COM_IN;
	  
      tmp=DigTable[structDis.u8ten];
	  if(tmp&BIT_A)
	  {
	    COM4_L;
		COM4_OUT;
	  }
	  
	  if(tmp&BIT_B)
	  {
	    COM5_L;
	    COM5_OUT;
	  }
	  
	  if(tmp&BIT_C)
	  {
	    COM6_L;
	    COM6_OUT;
	  }	    
	  
      if(structDis.u8hundred)
      {
        COM1_L;
        COM1_OUT;    
        COM3_L;
        COM3_OUT;    		
      }
      COM2_H;
      COM2_OUT; 
    }  
    break;
    
    case 2://COM3ߵƽ
    {
      ALL_COM_IN;
      tmp=DigTable[structDis.u8ten];
	  if(tmp&BIT_D)
	  {
	    COM1_L;
		COM1_OUT;
	  }
	  
	  if(tmp&BIT_E)
	  {
	    COM2_L;
	    COM2_OUT;
	  }
	  
	  if(tmp&BIT_F)
	  {
	    COM4_L;
	    COM4_OUT;
	  }	

	  if(tmp&BIT_G)
	  {
	    COM5_L;
	    COM5_OUT;
	  }	  
      tmp=DigTable[structDis.u8single];
	  if(tmp&BIT_A)
	  {
	    COM6_L;
	    COM6_OUT;
	  }

      COM3_H;
      COM3_OUT; 

    }     
    break;  

    case 3://COM4ߵƽ
    {
      ALL_COM_IN;   
	  tmp=DigTable[structDis.u8single];
	  if(tmp&BIT_B)
	  {
	    COM1_L;
		COM1_OUT;
	  }
	  
	  if(tmp&BIT_C)
	  {
	    COM2_L;
	    COM2_OUT;
	  }
	  
	  if(tmp&BIT_D)
	  {
	    COM3_L;
	    COM3_OUT;
	  }	

	  if(tmp&BIT_E)
	  {
	    COM5_L;
	    COM5_OUT;
	  }	  
 
	  if(tmp&BIT_F)
	  {
	    COM6_L;
	    COM6_OUT;
	  }

      COM4_H;
      COM4_OUT; 
    }     
    break;   

      
    case 4://COM5ߵƽ
    {
      ALL_COM_IN;    
	  tmp=DigTable[structDis.u8single];
	  if(tmp&BIT_G)
	  {
	    COM1_L;
		COM1_OUT;
	  }
	  
	  switch(structDis.u8right)
	  {
            case 4:
            case 3:
            case 2:
              COM6_L;
              COM6_OUT;
	    //break;	
	    case 1:
              COM4_L;
              COM4_OUT;
		
              COM2_L;	
          COM2_OUT; 		
		break;	
        default:
		break;			
	  }

      COM5_H;
      COM5_OUT; 

    }  
    break; 

    case 5://COM6ߵƽ
    {
      ALL_COM_IN;   
	  switch(structDis.u8right)
	  {        
		case 4:
		  COM2_L;
		  COM2_OUT;
		//break;	
	    case 3:
		  COM1_L;
		  COM1_OUT; 		
		break;	
        default:
		break;		
	  }
      COM6_H;
      COM6_OUT; 	  
    }     
    break;  
        
  } 
  structDis.u8step++; 
  if(structDis.u8step>5)
  {
    structDis.u8step=0;
  }   
}
/******************************************************************************************************
*      ƣvoid dis_ctr(void)
*      ܣ
*  ڲ
*  ڲstructDis.u8left  structDis.u8right structDis.u8hundred structDis.u8ten  structDis.u8single
*  ˵    
*      
*      ڣ202043
*      ߣм
******************************************************************************************************/

void dis_ctr(void) //ʾĴڲ˵
{
  static uint8_t i=0,u8per=100;

  if(i++>50)
  {
    i=0;  
	if(structLeftEarphone.u16AdcFilterValue)   //ADֵ0,ΪҪ	
	{
	  structDis.u8left++;
	  if(structDis.u8left>4)
	  structDis.u8left=1;
	}  
	else
	{
	  structDis.u8left=0;	
	}

    if(structRightEarphone.u16AdcFilterValue)  //ҶADֵ0,ΪҪ	
    {
	  structDis.u8right++;
	  if(structDis.u8right>4)
	  structDis.u8right=1; 
    } 
    else
    {
      structDis.u8right=0;
    } 		
  }       
  
  if(strucBattery.u8adcFinish)
  {
    strucBattery.u8adcFinish=0;
    if(structSwitch[_5V_IN].bitStatus==0)
    {
	  if(u8per>75)
	  {
	    //3.8V	  3115
	    if(strucBattery.u16AdcFilterValue<(3115+4*(u8per-75)))
	    {
		  if(u8per>0)
		  u8per--;
	    } 	
  	  }
	  else if(u8per>25)
 	  {
	    //3.5V	  2865	
	    if(strucBattery.u16AdcFilterValue<(2865+5*(u8per-25)))
	    {
		  if(u8per>0)
		  u8per--;
	    } 	
	  }
	  else 
	  {
	    //3.0V	  2457	
	    if(strucBattery.u16AdcFilterValue<(2457+4*u8per))
	    {
		  if(u8per>0)
		  u8per--;
	    } 	
	  }
          

      if(structSwitch[_5V_OUT].bitStatus)
      {
	    structDis.u8single=u8per%10;		 
	    structDis.u8ten=u8per%100/10;
	    structDis.u8hundred=u8per/100;  
      }	 
    }
    else
    {
	  if(u8per<25)  
	  { 
        //2457
	    if(strucBattery.u16AdcFilterValue>(2457+19*u8per))
	    {
		 // if(u8per<99)
		  u8per++;
	    } 	
	  } 
	  else if(u8per<75)
	  {
	    //2932
	    if(strucBattery.u16AdcFilterValue>(2932+5*(u8per-25)))
	    {
		  //if(u8per<99)
		  u8per++;
	    } 	
	  }
	  else
	  {
            //3182
	    if(strucBattery.u16AdcFilterValue>(3182+10*(u8per-75)))
	    {
		  if(u8per<99)
		  u8per++;
	    }
	  }

      structDis.u8ten=u8per%100/10;
      structDis.u8hundred=u8per/100;             
	  if(bitTwinkle)
	  {
        structDis.u8single=u8per%10;
	  }
	  else
	  {
	    structDis.u8single=10;//رղʾ
	  } 
 
    }
  }

	
}