#ifndef   __TIM_
#define   __TIM_
#define  LED2_ON        FP14=0
#define  LED2_OFF       FP14=1

#define  LED1_ON        FP13=0
#define  LED1_OFF       FP13=1

#define  IR_EN          FP33=1
#define  IR_DIS         FP33=0

#define  MOTOR_EN       FP22=1
#define  MOTOR_DIS      FP22=0

#define LED2_DUTY_MAX     255

#define LED2_STATUS_OFF   0
#define LED2_STATUS_FADE  1
#define LED2_STATUS_ON    2


//struct TIMER_STRUCT
//{
//  uint8_t u8SecTmp;
//  uint8_t u8MinTmp;
//  uint8_t u8HourTmp;              
//};
//extern struct TIMER_STRUCT timerStruct;
struct STRUCT_LED2
{
  uint8_t u8led2Status;
  uint8_t u8led2Duty;
  uint8_t u8step;              
};


extern struct STRUCT_LED2 structLED2;


extern uint8_t u8workStep;
extern bit bit1ms;
extern bit bit10ms;
extern bit bit100ms;


extern void t0_enable(void);
extern void t0_disable(void);

extern void pwm21_enable(void);
extern void pwm21_disable(void);

extern void pwm22_enable(void);
extern void pwm22_disable(void);

extern void led2_ctr(void);
extern void work_ctr(void);
extern void chrg_ctr(void);
#endif