#include <FC2722.h>
#include"key.h"
#include"tim.h"
#include"touch.h"

bit bit1ms=0;
bit bit5ms=0; 
bit bit10ms=0;
bit bit100ms=0;

uint8_t u8workStep=0;
void chrg_ctr(void);
struct STRUCT_LED2 structLED2={0,0,0};
/******************************************************************************************************
*      ƣжϷ
*      ܣ
*  ڲ
*  ڲ
*      ڣ2019.6.14
*      ߣм
******************************************************************************************************/
void __interrupt[0x8] isr(void)
{
  static uint8_t i=0,j=0,t=0;
  if(T0IF)
  {	  
    T0IF=0;  
    T0C=68;      //װֵ	  
      i++;
      if(i>3)
      {
        i=0;
        bit1ms=1;
        j++;
        t++;
      }
	  if(j>9)
	  {
	    j=0;
		bit10ms=1; 
      }
      if(t>99)
      {
	    t=0;
        bit100ms=1;
      }
  } 
  	 
  if(TKTMRIF)
  {

    TKTMREN=0;            //ر ʱ 
    TKTMRIF=0;            // ־λ  

    TKRDS0=0;             //ѡȡTK1~TK4

    u8TKTMCH=TKTMCH;
	u8TKTMCL=TKTMCL;

    TKTCEN=0;         // ֹͣ  0

  }		
}

/******************************************************************************************************
*      :
*      ܣرPWM
*  ڲ   
*  ڲ
*      ڣ2019.10.12
*      ߣ
******************************************************************************************************/
void pwm21_enable(void)
{
  TM2D0=202;   //PWM11ߵƽʱ,TM1D0-TM1C
  TM2C=98;    //ʼֵ
  PWM2E=0x10;//P34PWM11ź
  TM2M=0xE7;
}
void pwm21_disable(void)
{
  PWM2E=0x00;
  FP34=1;
}

void pwm22_enable(void)
{

  TM1D0=255-150;   //PWM10ߵƽʱ,TM1D0-TM1C
  TM1C=255-150;    //ʼֵ
  PWM1E=0x10;//P14PWM10ź
  TM1M=0xD7;

  //TM1D1=128; //PWM11ߵƽʱ,TM1D0-TM1C
  //TM1C=0;    //ʼֵ
  //PWM1E=0x21;//P14PWM11ź
  //TM1M=0xD6;
}
void pwm22_disable(void)
{
  PWM1E=0x00;
  FP14=1;
}
/******************************************************************************************************
*      ƣvoid t0_enable(void)
*      ܣt0ʱж
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ2019614
*      ߣм
******************************************************************************************************/
void t0_enable(void)
{
  T0M=0xD0;       //T0TR T0PS2 T0PS1 T0PS0 - - - -   000,Fcpu/256 001/128 010/64 011/32 100/16 101/8 110/4 111/2
  T0C=68;        //
  T0IE=1;         //T0ж
  FGIE=1;
}
/******************************************************************************************************
*      ƣvoid t0_disable(void)
*      ܣt0ʱж
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ2019614
*      ߣм
******************************************************************************************************/
void t0_disable(void)
{
  T0M=0x00;	
  T0IE=0;
 // FGIE=0;
}

/******************************************************************************************************
*       ƣvoid work_ctr(void)
*       ܣ
*  ˵     
*  ڲ
*  ڲ
*       
******************************************************************************************************/
void work_ctr(void)
{ 
  static uint8_t x=0;
  if((u8mode==STATUS_ON)||(u8mode==STATUS_0FF_TMP))
  {
	  switch(u8workStep)
	  {
	    case 0:
		  x++;
		  switch(x)
		  {
		    case 16:	
			  LED1_ON;	
			  break;	
		    case 32:
			  LED1_OFF;	
			  break;	
		    case 48:	
			  LED1_ON;	
			  break;	
		    case 64:
			  LED1_OFF;
			  x=0;
			  IR_EN;               //IRԴ
			  pwm21_enable();      //38KHz    1/3Duty
			  u8workStep=1;
			  break;					
		  }
		  break;
		
		  case 1:
		  if(structKey[_IR].bitShortClick)
		  {
		    x++;
			LED1_ON;
			MOTOR_EN;
			if(x>79)
			{
			  x=0;
			  LED1_OFF;
			  MOTOR_DIS;
			  structKey[_IR].bitShortClick=0;
			}
		  }
		  if(u8mode==STATUS_0FF_TMP)
		  {
		    x=0;
		    u8workStep=2;	
		  }
		break;
		
		case 2:
		  LED1_ON;
          x++;  
		if(x>99)
		{
		  x=0;
          u8workStep=0;
		  u8mode=STATUS_0FF;
		}
		break;

	  }	
  }
}


/******************************************************************************************************
*       ƣvoid led2_ctr(void)
*       ܣLED2,ƽ,LED2
*  ڲ
*  ڲ
*  ˵     TIM4˺1msһTIM4ж
*       
******************************************************************************************************/
void led2_ctr(void)
{ 
  switch(structLED2.u8led2Status)
  {
    case LED2_STATUS_OFF:
	  LED2_OFF;
	  break;	

    case LED2_STATUS_ON:
      if(PWM1E)
      pwm22_disable();
      LED2_ON;
	break;	

  
    case LED2_STATUS_FADE:
    if(PWM1E==0)
    pwm22_enable();
    switch(structLED2.u8step)
    {
      case 0:
	  	structLED2.u8led2Duty=255-150;
		structLED2.u8step=1;
	  break;
	  
	  case 1:
		if(structLED2.u8led2Duty>(LED2_DUTY_MAX-1))
        {  
	      structLED2.u8step=2;
          break;
        }  
	  	structLED2.u8led2Duty++;
	  break;

	  case 2:
		if(structLED2.u8led2Duty<=(255-150))
        {  
		  structLED2.u8step=1;
          break;
        }	  	
	  	structLED2.u8led2Duty--;
	  break;	
    }
	break;
  }
  TM1D0=structLED2.u8led2Duty;
}
/******************************************************************************************************
*       ƣvoid chrg_ctr(void)
*       ܣ
*  ˵     
*  ڲ5VCHRGŵƽ״̬
*  ڲstructLED2.u8led2Status
*       
******************************************************************************************************/
void chrg_ctr(void)
{ 
  if(u8mode==STATUS_CHRG)
  {
    if(structSwitch[_CHRG].bitStatus)
    {
      structLED2.u8led2Status=LED2_STATUS_ON;           //LED2
    }
	else
	{
      structLED2.u8led2Status=LED2_STATUS_FADE;         //ڳLED2
	}
  }
}

