#ifndef   __ADC_H__
#define   __ADC_H__

//#define   ADC_SELECT_BATTERY_CH    ADM=0x9A
//#define   ADC_SELECT_AIN0_CH       ADM=0x90
//#define   ADC_SELECT_AIN1_CH       ADM=0x91
#define   ADC_SELECT_AIN2_CH       ADM=0x92

struct ADC_STRUCT
{
  uint8_t   u8adcFinish;
  uint8_t   u8cnt; 
  uint16_t  u16max;
  uint16_t  u16min;
  uint16_t  u16sum;
  uint16_t  u16AdcValue;  
  uint16_t  u16AdcFilterValue;          
};

//extern struct ADC_STRUCT strucBattery;
//extern struct ADC_STRUCT strucAIN0;
//extern struct ADC_STRUCT strucAIN1;

extern struct ADC_STRUCT strucAIN2;

extern void adc_ctr(void);
extern void read_adc_chs(void);
extern void adc_init(void);
extern void get_adc_convert_value(struct ADC_STRUCT *adcvar);
extern void adc_filter(struct ADC_STRUCT *adcvar);
#endif