#include "FC2720.h"
#include "time.h"
#include "key.h"
#include "global.h"
#include "adc.h"
#include "delay.h"

void main(void)
{
	uint8_t i=0;

	system_init();
	t0_enable();
	adc_init();

	for(i=0;i<200;i++)
  	{
   		delay_1ms(1);
		get_adc_convert_value(&strucAIN2);	
		adc_filter(&strucAIN2);
  	}

	while(1)
	{
		if(bit250us)
		{
			bit250us=0;
			io_pwm_output();
		}
		
		if(bit1ms)
		{
			bit1ms=0;
		}
		
		if(bit10ms)
		{
			bit10ms=0;
			WDTR=0X5A;    //ι
			key_scan();
			key_service();
			LED_CTR();
		}
		
		if(bit50ms)
		{
			bit50ms=0;
			get_adc_convert_value(&strucAIN2);	
			adc_filter(&strucAIN2);
			sleep_mode();
		}
	}
}