#ifndef   __KEY_H
#define  __KEY_H


#define    P_KEY_K1    FP11
#define    P_CHRG      FP21
#define    P_5V_IN     FP15
#define    P_IR        FP32

#define _5V_IN           0
#define _CHRG            1

#define K1               0
#define _IR              1

struct KEY_STRUCT
{
  uint8_t   bitShortClickTmp;       //   
  uint8_t   bitShortClick;          // 
  uint8_t   bitLock;                //
  uint8_t   bitLongClick;           //  
  uint8_t u8count;               //   
};  


struct SWITCH_STRUCT
{
  uint8_t   bitStatus;             //    
  uint8_t u8count;              //   
  uint8_t u8count2;             //   
}; 

#define STATUS_0FF       0
#define STATUS_ON        1
#define STATUS_CHRG      2
#define STATUS_0FF_TMP   3

extern uint8_t u8mode;

extern struct SWITCH_STRUCT structSwitch[2];
extern struct KEY_STRUCT structKey[2];   

extern void scan_key(void);
extern void scan_switch(void);
extern void mode_ctr(void);

#endif